//+------------------------------------------------------------------+
//|                                                      iEnergy.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

#property indicator_buffers   4
#property indicator_color1    Green
#property indicator_color2    Red
#property indicator_color3    Yellow
#property indicator_color4    White
#property indicator_width1    4
#property indicator_width2    4
#property indicator_width3    4
#property indicator_width4    2
#property indicator_minimum   0

extern int PERIOD=13;

double BULL[];
double BEAR[];
double FLAT[];
double LINE[];

double SMA(int shift)
{
   double SMA=0;
   for(int i=0; i<PERIOD; i++) SMA+=ENERGY(shift+i);
   return(SMA/PERIOD);
}

int SUM(double price)
{
   string P=DoubleToStr(price,Digits);
   int S=0;
   for(int i=0; i<StringLen(P); i++) S+=StrToInteger(StringSubstr(P,i,1));
   return(S);
}

int POWER(int shift)
{
   return(SUM(Open[shift])+SUM(High[shift])+SUM(Low[shift])+SUM(Close[shift]));
}

double EF(int shift)
{
   int P1=POWER(shift);
   if(P1<1) return(0);
   shift++;
   int P2=POWER(shift);
   if(P2<1) return(0);
   double P3=MathMin(P1,P2)/MathMax(P1,P2);
   return(P3);
}

double ENERGY(int shift)
{
   return(Volume[shift]*MathPow(EF(shift),2));
}

void DRAW(int shift)
{
   BULL[shift]=EMPTY_VALUE;
   BEAR[shift]=EMPTY_VALUE;
   FLAT[shift]=EMPTY_VALUE;
   LINE[shift]=SMA(shift);
   double E1=ENERGY(shift);
   int S=shift; shift++;
   double E2=ENERGY(shift);
   if(E1>E2) 
      BULL[S]=E1; else
   if(E1<E2) 
      BEAR[S]=E1; else FLAT[S]=E1;
}   

bool BARS(int shift)
{
   return(shift<Bars-IndicatorCounted());
}

void start()
{
   for(int i=0; BARS(i); i++) DRAW(i);
}
  
void init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,BULL);
   SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,BEAR);
   SetIndexStyle(1,DRAW_HISTOGRAM); 
   SetIndexBuffer(2,FLAT);
   SetIndexStyle(2,DRAW_HISTOGRAM); 
   SetIndexBuffer(3,LINE);
   SetIndexStyle(3,DRAW_LINE); 
   IndicatorDigits(Digits);
   IndicatorShortName("iEnergy");    
}

